%define confdir %{_sysconfdir}/%{name}
%define alphatag 9f575f26d1db

Name:       transifex
Version:    0.5
Release:    0.2%{?dist}.hg%{alphatag}
Summary:    A system for distributed translation submissions

Group:      Applications/Internet
License:    GPLv2
URL:        http://transifex.org/
# hg clone -r %{alphatag} http://code.transifex.org/index.cgi/mainline/ transifex-0.5
# tar zcf transifex-0.5.tar.gz transifex-0.5
Source0:    transifex-0.5.tar.gz
Source1:    django-settings.py.in
Patch0:     transifex-0.5-el5.patch
BuildRoot:  %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
BuildArch:  noarch

BuildRequires:  python-sphinx
Requires:   Django django-authopenid django-contact-form django-evolution
Requires:   django-notification django-pagination django-tagging
Requires:   python-markdown python-polib python-pygments
Requires:   mercurial
Requires:   intltool >= 0.40.5

%description
Transifex is a web-system that facilitates the process of submitting
translations in remote and disparate version control systems (VCS).

%package extras
Summary:    Additional support for Transifex
Group:      Applications/Internet
Requires:   transifex = %{version}
Requires:   cvs pysvn bzrtools git

%description extras
This package adds extra options to Transifex.

  * cvs support
  * svn support
  * bzr support
  * git support

%prep
%setup -q
%patch0 -p1

%build
rm -rf .hg* build-tools
rm -r vcs/tests
cd docs
make html

%install
rm -rf $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT%{_datadir}/%{name}
find -mindepth 1 -maxdepth 1 -type d \( \( -name .hg -o \
    -name build-tools -o -name docs \) -prune -o -print \) | \
    xargs cp -a -t $RPM_BUILD_ROOT/%{_datadir}/%{name}
cp -a *.py $RPM_BUILD_ROOT%{_datadir}/%{name}

for vcs in cvs svn bzr hg git
do
    mkdir -p $RPM_BUILD_ROOT%{_localstatedir}/lib/%{name}/scratchdir/sources/"$vcs"
done

install -d -m 0755 $RPM_BUILD_ROOT/%{confdir}

sed -n -e '/ADDITIONAL VCS OPTIONS/q;p' \
    $RPM_BUILD_ROOT%{_datadir}/%{name}/settings.py > \
    $RPM_BUILD_ROOT%{confdir}/00-default.conf

sed -n -e '/EXTRA LOCAL SETTINGS/q;/ADDITIONAL VCS OPTIONS/,$p' \
    $RPM_BUILD_ROOT%{_datadir}/%{name}/settings.py > \
    $RPM_BUILD_ROOT%{confdir}/10-extras.conf

sed -e 's!\[\[confpath\]\]!%{confdir}!' %{SOURCE1} > \
    $RPM_BUILD_ROOT%{_datadir}/%{name}/settings.py

%clean
rm -rf $RPM_BUILD_ROOT

%post
if grep -q '[[SECRETKEY]]' %{confdir}/%{name}/00-default.conf
then
    key=$(python << EOF
import random
print ''.join(chr(random.randint(35, 126)) for x in xrange(40))
EOF
)
    sed -i -e "s!\[\[SECRETKEY\]\]!$key!" \
        %{confdir}/%{name}/00-default.conf
fi

%files
%defattr(-,root,root,-)
%doc LICENSE README docs/_build/html
%dir %{confdir}
%config(noreplace) %{confdir}/00-default.conf
%dir %{_datadir}/%{name}
%{_datadir}/%{name}/__init__.py
%{_datadir}/%{name}/__init__.py[co]
%{_datadir}/%{name}/manage.py
%exclude %{_datadir}/%{name}/manage.py[co]
%{_datadir}/%{name}/settings.py
%{_datadir}/%{name}/settings.py[co]
%exclude %{_datadir}/%{name}/settings_*.py*
%{_datadir}/%{name}/urls.py
%{_datadir}/%{name}/urls.py[co]
%{_datadir}/%{name}/actionlog
%{_datadir}/%{name}/languages
%{_datadir}/%{name}/projects
%{_datadir}/%{name}/releases
%{_datadir}/%{name}/repowatch
%{_datadir}/%{name}/simpleauth
%{_datadir}/%{name}/simplelock
%{_datadir}/%{name}/site_media
%{_datadir}/%{name}/templates
%{_datadir}/%{name}/transifex
%{_datadir}/%{name}/translations
%{_datadir}/%{name}/txcollections
%dir %{_datadir}/%{name}/vcs
%{_datadir}/%{name}/vcs/*.py
%{_datadir}/%{name}/vcs/*.py[co]
%dir %{_datadir}/%{name}/vcs/lib
%{_datadir}/%{name}/vcs/lib/*.py
%{_datadir}/%{name}/vcs/lib/*.py[co]
%dir %{_datadir}/%{name}/vcs/lib/support
%{_datadir}/%{name}/vcs/lib/support/__init__.py
%{_datadir}/%{name}/vcs/lib/support/__init__.py[co]
%{_datadir}/%{name}/vcs/lib/support/commands.py
%{_datadir}/%{name}/vcs/lib/support/commands.py[co]
%dir %{_datadir}/%{name}/vcs/lib/types
%{_datadir}/%{name}/vcs/lib/types/__init__.py
%{_datadir}/%{name}/vcs/lib/types/__init__.py[co]
%{_datadir}/%{name}/vcs/lib/types/dummy.py
%{_datadir}/%{name}/vcs/lib/types/dummy.py[co]
%{_datadir}/%{name}/vcs/lib/types/hg.py
%{_datadir}/%{name}/vcs/lib/types/hg.py[co]
%{_datadir}/%{name}/vcs/management/
%dir %{_localstatedir}/lib/%{name}
%dir %{_localstatedir}/lib/%{name}/scratchdir
%dir %{_localstatedir}/lib/%{name}/scratchdir/sources
%dir %{_localstatedir}/lib/%{name}/scratchdir/sources/hg

%files extras
%defattr(-,root,root,-)
%doc LICENSE README
%config(noreplace) %{confdir}/10-extras.conf
%{_datadir}/%{name}/vcs/lib/support/cvs.py
%{_datadir}/%{name}/vcs/lib/support/cvs.py[co]
%{_datadir}/%{name}/vcs/lib/types/cvs.py
%{_datadir}/%{name}/vcs/lib/types/cvs.py[co]
%{_datadir}/%{name}/vcs/lib/types/svn.py
%{_datadir}/%{name}/vcs/lib/types/svn.py[co]
%{_datadir}/%{name}/vcs/lib/types/bzr.py
%{_datadir}/%{name}/vcs/lib/types/bzr.py[co]
%{_datadir}/%{name}/vcs/lib/support/git.py
%{_datadir}/%{name}/vcs/lib/support/git.py[co]
%{_datadir}/%{name}/vcs/lib/types/git.py
%{_datadir}/%{name}/vcs/lib/types/git.py[co]
%dir %{_localstatedir}/lib/%{name}/scratchdir/sources/cvs
%dir %{_localstatedir}/lib/%{name}/scratchdir/sources/svn
%dir %{_localstatedir}/lib/%{name}/scratchdir/sources/bzr
%dir %{_localstatedir}/lib/%{name}/scratchdir/sources/git

%changelog
* Mon Mar 09 2009 Ignacio Vazquez-Abrams <ivazqueznet+rpm@gmail.com> 0.5-0.2.hg9f575f26d1db
- Fix build for EL5

* Mon Mar 09 2009 Ignacio Vazquez-Abrams <ivazqueznet+rpm@gmail.com> 0.5-0.1.hg9f575f26d1db
- Remove vcs app tests
- Add support for simple authentication

* Fri Mar 06 2009 Ignacio Vazquez-Abrams <ivazqueznet+rpm@gmail.com> - 0.5-0.0.hg43f8e9924fa2
- Update to 0.5 beta

* Wed Jan 28 2009 Dimitris Glezos <dimitris@glezos.com> - 0.3.2
- Version 0.3.2

* Sat Aug 01 2008 Dimitris Glezos <dimitris@glezos.com> - 0.3.1
- Version 0.3.1

* Sun Jul 20 2008 Dimitris Glezos <dimitris@glezos.com> - 0.3-0
- Version 0.3

* Sun Feb 10 2008 Dimitris Glezos <dimitris@glezos.com> - 0.2-0
- Overhaul of file uploads, now supporting non-UTF uploads
- Admins are now members of 'l10n-admin' group

* Mon Jan 14 2008 Dimitris Glezos <dimitris@glezos.com> - 0.1.1-0
- Corrected a Unicode issue (non-ascii user names)

* Sat Sep 29 2007 Mike McGrath <mmcgrath@redhat.com> - 0.1-5
- Added logrotate and a few other pieces
- Added transifex user and a few permissions changes

* Thu Sep 27 2007 Mike McGrath <mmcgrath@redhat.com> - 0.1-3
- Added BR TurboGears
- Added transifex to cp -adv
- Added a mkdir

* Sat Jun 23 2007 Dimitris Glezos <dimitris@glezos.com> - 0.1-1
- Initial creation
